<template>
  <div class="category">
    <h2 class="title">
      {{ category.title }}
    </h2>
    <div class="actions">
      <Button type="text" color="dark" round size="sm" light class="edit" @click.native="$router.push(`/dashboard/admin/categories/${category.id}`)">
        <template #icon>
          <EditIcon />
        </template>
      </Button>
      <InlineDeleteButton @delete="onDelete" />
    </div>
  </div>
</template>

<script>
import Button from "@/components/base/Button";
import EditIcon from "@/assets/svgs/edit.svg";
import InlineDeleteButton from "@/components/base/InlineDeleteButton";

export default {
  name: "Category",
  components: {
    Button,
    EditIcon,
    InlineDeleteButton
  },
  props: {
    category: {
      type: Object,
      required: true
    }
  },
  methods: {
    onDelete() {
      this.$store.dispatch('shop/deleteCategory', {
        id: this.category.id,
        token: this.$store.getters['auth/getToken']
      }).then(response => {
        if (response.status === 200) {
          this.$store.dispatch('notifications/push', {
            message: 'دسته بندی با موفقیت حذف شد.',
            light: true,
            type: 'success',
            timeout: 2500
          });
          this.$emit('delete', this.category.id);
        } else {
          this.$store.dispatch('notifications/push', {
            message: 'خطا در اتصال به سرور! لطفا دقایقی دیگر دوباره امتحان کنید.',
            type: 'error',
            timeout: 3500
          });
        }
      }).catch(error => {
        if (error.response.status === 404) {
          this.$store.dispatch('notifications/push', {
            message: 'دسته بندی انتخاب شده وجود ندارد.',
            type: 'error',
            timeout: 3500
          });
        } else {
          this.$store.dispatch('notifications/push', {
            message: 'خطا در اتصال به سرور! لطفا دقایقی دیگر دوباره امتحان کنید.',
            type: 'error',
            timeout: 3500
          });
        }
      });
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.category
  display flex
  align-items center
  justify-content space-between
  padding $xsm
  &:not(:last-of-type)
    border-bottom 1px solid rgba(black, .1)
  &:hover
    background-color rgba(black, .03)

.actions
  display flex
  margin-right $md

.edit
  margin-left $xsm

.title
  font-size $font-size
  color $black
  font-weight 400
</style>